/*
   Copyright (C) 1988,1989 The GAP Development Company

   All Rights Reserved
   
   This source code is considered to be confidential information proprietary
   to The GAP Development Company.  It is prohibited and punishable by law
   to use or duplicate any part of this information.
 

   GAPCDR.H

   Header file for GAPCDR modules

   Defines external declarations and includes gastruc.h which defines
   global structures and function prototypes.

*/


#include "gapstruc.h"

   /*********************************************************************/
   /*  Variables initialized by reading DOOR.SYS                        */
   /*********************************************************************/

   extern int local;              /* 0 = remote user, 1 = local user  */
   extern int port;               /* com port being used              */
   extern int userbaud;           /* remote user's bps rate           */
   extern int parity;             /* actually data bits, not used     */
   extern int node;               /* node number in use, 0 = single   */
   extern int baud;               /* DTE bps rate                     */
   extern int screen;             /* 0 = screen off, 1 = screen on    */
   extern int printer;            /* 0 = printer off, 1 = printer on  */
   extern int bell;               /* 0 = page bell off, 1 = bell on   */
   extern int alarm;              /* 0 = caller alarm off, 1 = on     */
   extern int level;              /* user's security level            */
   extern int minsleft;           /* minutes left at door start       */
   extern int color;              /* 0 = no color, 1 = color          */
   extern int page;               /* page length                      */
   extern int expert;             /* 0 = novice, 1 = expert           */

   extern long timeson;           /* # of times on                    */
   extern long recnum;            /* user's record number             */
   extern long uploads;           /* total number of uploads          */
   extern long downloads;         /* total number of downloads        */
   extern long upbytes;           /* total upload bytes               */
   extern long downbytes;         /* total download bytes             */
   extern long maxbytes;          /* max bytes can download           */

   extern char username   [];     /* user's full name                 */
   extern char fname      [];     /* user's first name                */
   extern char lname      [];     /* user's last name                 */
   extern char city       [];     /* user's home town                 */
   extern char hphone     [];     /* user's home phone number         */
   extern char bphone     [];     /* user's business phone number     */
   extern char password   [];     /* user's password                  */
   extern char lastdate   [];     /* last date user was on            */
   extern char subscrip   [];     /* date user's subscription expires */


   /*********************************************************************/
   /*  global variables                                                 */
   /*********************************************************************/

   extern dopcb;                  /* if 1, then BBS is a pcb system      */
   extern noup;                   /* if 1, dont uppercase characters     */
   extern char fileshow;          /* 1 if showing file, 0 if not         */
   extern char redisplay;         /* true if wants to start over         */
   extern char usemore1;          /* true if showing a file              */
   extern char view;              /* true if want a more prompt          */
   extern char endview;           /* true if dont want to see any more   */
   extern char NS;                /* true if in Non Stop mode            */
   extern char instatus;          /* if doing status line,bypas our BIOS */
   extern char chat;              /* true if chatting with user          */
   extern char clockon;           /* 0 no clock, 1 display clock         */
   extern int timeleft;           /* time user has left                  */
   extern int timecredit;
   extern int lines;              /* # of lines currently displayed      */
   extern char anystring   [];    /* global garbage collector            */
   extern char maindir     [];    /* path to the BBS main dir            */
   extern char gendir      [];    /* path to the BBS gen dir             */
   extern char sysname     [];    /* sysop's name                        */
   extern char strtime     [];    /* holds the time string               */
   extern char curtime     [];    /* holds the current time as a string  */
   extern char bbs_dir     [];    /* path to BBS default dir             */
   extern char board_name  [];    /* name of the BBS                     */
 
   extern long temptime;          /* for calculating time out            */
   extern long timenow;           /* long integer for current time       */
   extern long starttime;         /* long integer for time door opened   */


   extern char  BLACK [];         /* ANSI color strings                  */
   extern char  RED [];
   extern char  GREEN [];
   extern char  BROWN []; 
   extern char  BLUE [];
   extern char  MAGENTA []; 
   extern char  CYAN [];
   extern char  WHITE [];
   extern char  BBLACK [];
   extern char  BRED [];
   extern char  BGREEN [];
   extern char  YELLOW [];
   extern char  BBLUE [];
   extern char  BMAGENTA [];
   extern char  BCYAN [];
   extern char  BWHITE [];

